//不规范
module clkDiv(  clk , rst , clk_div );  
    parameter       NUM_DIV = 6;  
    input           clk        ;
    input           rst        ;  
    output          clk_div    ;  

    reg             clk_div    ;  


//规范
module clkDiv#(
     parameter NUM_DIV = 6 
    )(
     input          clk
    ,input          rst

    ,output reg     clk_div
);    

//_____________________________________________________________________

//不规范
module clkDiv#(
     parameter NUM_DIV = 6 
    )(
     input          clk_i
    ,input          rst_i

    ,input          clk_en_i
    ,output reg     clk_div_o
);    
    reg [3:0]   cnt_r;
    wire        timeOut_w = cnt_r==0 ;

  

//规范
module clkDiv#(
     parameter NUM_DIV = 6 
    )(
     input          clk
    ,input          rst

    ,input          clk_en
    ,output reg     clk_div
);    
    reg [3:0]   cnt;
    wire        timeOut = cnt==0 ;
//_____________________________________________________________________

//不规范
clkDiv#(
    .NUM_DIV  (     NUM_DIV ) 
    )clkDiv(
     .clk_i         (    clk_w         )              
    ,.rst_i         (    rst_w         )       
    
    ,.clk_en_i      (    clk_en_w      )                 
    ,.clk_div_o     (    clk_div_w     )                   
);   

//规范
clkDiv#(
    .NUM_DIV  (     NUM_DIV ) 
    )clkDiv(
     .clk           (    clk           )                   
    ,.rst           (    rst           )      
       
    ,.clk_en        (    clk_en        )               
    ,.clk_div       (    clk_div       )                
);  




    parameter NUM_DIV = 6;

    reg [3:0]cnt;

//不规范
always @(posedge clk )
    if( rst  ) begin
        cnt     <= 4'd0;
        clk_div <= 1'b0;
    end
    else if(cnt < NUM_DIV / 2 - 1) begin
        cnt     <= cnt + 1'b1;
        clk_div <= clk_div;
    end
    else begin
        cnt     <= 4'd0;
        clk_div <= ~clk_div;
    end
    
//规范
always @(posedge clk )
if( rst )                           cnt<= 4'd0;
else if(cnt == NUM_DIV / 2 -1 )     cnt<= cnt + 1'b1;
else                                cnt<= 4'd0;

always @(posedge clk )
if( rst_n)                          clk_div<= 1'b0;
else if(cnt == NUM_DIV / 2  -1 )    clk_div<= !clk_div;
    



always @(posedge clk )
if( rst )                           cnt<= 4'd0;
else if(cnt == NUM_DIV / 2 -1 )     cnt<= cnt + 1'b1;
else                                cnt<= 4'd0;

always @(posedge clk )
if( rst_n)                          clk_div<= 0;
else if(cnt == NUM_DIV / 8  -1 )    clk_div<= 1;
else if(cnt == NUM_DIV / 6  -1 )    clk_div<= 0;
else if(cnt == NUM_DIV / 4  -1 )    clk_div<= 1;
else if(cnt == NUM_DIV / 2  -1 )    clk_div<= 0;

//_____________________________________________________________________

//不规范
always @(posedge clk )begin
    if( rst )begin
        axis_tvalid<= 1'd0;
    end
    else if( axis_tvalid & axis_tready )begin
        axis_tvalid<= 1'd0;
    end
    else if( tx )begin
        axis_tvalid<= 1'd1;
    end
end


//规范
always @(posedge clk )
if( rst )                           axis_tvalid<= 1'd0;
else if( axis_tvalid & axis_tready )axis_tvalid<= 1'd0;
else if( tx )                       axis_tvalid<= 1'd1;




//_____________________________________________________________________



endmodule

//_____________________________________________________________________
module gjSPI_Master #(
         parameter CLK_DIV   = 8'd125     //spi clk div
        ,parameter ADDR_LEN  = 7        
        ,parameter NUMB_LEN  = 3        
        ,parameter DATA_LEN  = 16       
  )( 
  
         input                      clk 
        ,input                      rst 
                    
        ,input                      cmd_tvalid          //rcv cmd
        ,output                     cmd_tready
        ,input      [NUMB_LEN-1:0]  cmd_number  
        ,input                      cmd_type            // 1:read 0:write 
        ,input      [ADDR_LEN-1:0]  cmd_addr  
        ,input      [DATA_LEN-1:0]  cmd_din
        ,output reg                 cmd_din_tready
                    
        ,output reg [DATA_LEN-1:0]  cmd_dout            //back data
        ,output reg                 cmd_dout_tvalid  
        
        ,input                      spi_SDO             //spi interface
        ,output reg                 spi_SCLK
        ,output                     spi_SDI
        ,output reg                 spi_csn        
);




//_____________________________________________________________________


module rstBlock#(
         parameter DL   = 2     
  )( 
         input          areset
        ,input          clk

        ,output reg     rst
        ,output reg     rstn
);

reg [DL-1 :1 ] rstDelay;

always@(posedge clk or posedge areset)
if( areset )    rstDelay<={DL-1{1'b1}};
else            rstDelay<=rstDelay<<1;

always@(posedge clk or posedge areset)
if( areset )    rst<=0;
else            rst<=rstDelay[DL-1];

always@(posedge clk or posedge areset)
if( areset )    rstn<=0;
else            rstn<=!rstDelay[DL-1];

endmodule


module rstTop(
         input          areset
        ,input          clk_100m
        ,input          clk_125m
        ,input          clk_200m

        ,output         rst_100m
        ,output         rst_125m
        ,output         rst_200m

        ,output         rstn_100m
        ,output         rstn_125m
        ,output         rstn_200m
);
wire  aresets   = { rst_125m , rst_100m , areset    };
wire  clks      = { clk_200m , clk_125m , clk_100m  };
wire  rsts      = { rst_200m , rst_125m , rst_100m  };
wire  rstns     = { rstn_200m, rstn_125m, rstn_100m };

   genvar i;
   generate
      for (i=0; i< CHIP_NUM; i=i+1)
      begin: RST    

            rstBlock#(
                    .DL             (    2    )       
            )rstBlock( 
                     .areset    (    areset    )             
                    ,.clk       (    clks    [i]   )  

                    ,.rst       (    rsts    [i]   )      
                    ,.rstn      (    rstns   [i]   )       
            );
      end
   endgenerate

endmodule

wire        clk_100m   ;
wire        clk_125m   ;
wire        clk_200m   ;

wire        rst_100m   ;                
wire        rst_125m   ;
wire        rst_200m   ;

wire        rstn_100m  ;
wire        rstn_125m  ;
wire        rstn_200m  ;

rstTop rstTop(
         .areset        (    areset        )                         
        ,.clk_100m      (    clk_100m      )                   
        ,.clk_125m      (    clk_125m      )                   
        ,.clk_200m      (    clk_200m      )  
        
        ,.rst_100m      (    rst_100m      )                   
        ,.rst_125m      (    rst_125m      )                   
        ,.rst_200m      (    rst_200m      )    
        
        ,.rstn_100m     (    rstn_100m     )                    
        ,.rstn_125m     (    rstn_125m     )                    
        ,.rstn_200m     (    rstn_200m     )                    
);



//_______________________________________________________________

module gjUartTx(
         input              rst
        ,input              clk
        ,input              clk_div

        ,input              tx_tvalid
        ,output             tx_tready
        ,input     [7:0]    tx_tdata

        ,output             uartTx
        ,output reg         uartTx_en
);

reg     [9:0]  txData;
always@(posedge clk )
if( rst )                           txData<= 10'h3ff;
else if( tx_tvalid & !uartTx_en  )  txData<={1'b1, tx_tdata, 1'b1 } ;
else if( clk_div )                  txData<={1'b1 ,txData [9:1] };

assign uartTx = txData[0] ;

reg     [9:0]  shift;
always@(posedge clk )
if( rst )                           shift<= 10'h0;
else if( tx_tvalid & !uartTx_en  )  shift<= 10'h3f;
else if( clk_div )                  shift<={1'b0 ,shift [9:1] };

assign uartTx_en = shift[0] ;

assign tx_tready = shift[1:0] ==1 & clk_div ;

endmodule



`timescale 1ns / 1ns
//////////////////////////////////////////////////////////////////////////////////
// Company:   guiJia
// Engineer:  kejie ma
// 
// Create Date: 2021/01/27 09:33:28
// Design Name: 
// Module Name: clockReset
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


